﻿Imports System.IO
Imports MySql.Data.MySqlClient
Imports System.Data
Imports System.Data.Common
Imports System.Data.OleDb
Imports System.Data.SqlServerCe

Public Class frmDataspy
    Private _Connection As DbConnection
    Private _DataTable As DataTable
    Private _ProviderFactory As DbProviderFactory
    Private _Schemes As New List(Of String)
    Private _Tables As New List(Of String)
    Private _Table As String
    Private _Filter As String

    Private Sub lb_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        _Filter = ""
        If DirectCast(sender, ListBox).SelectedIndex < 0 Then Return
        _DataTable = TryCast(dgvContent.DataSource, DataTable)
        _DataTable.Dispose()
        _Connection.Open()
        If sender Is lbSchema Then
            scContent.Panel1Collapsed = True
            Dim schema = _Schemes(lbSchema.SelectedIndex)
            Dim message = "Connection.GetSchema(""" & schema & """)"
            Try
                _DataTable = _Connection.GetSchema(schema)
                dgvContent.DataSource = _DataTable
            Catch ex As Exception
                MessageBox.Show("Datenbankschema konnte nicht ausgelesen werden werden")
            End Try
        ElseIf sender Is lbTable Then
            scContent.Panel1Collapsed = False
            If bgwLoad.IsBusy Then
                MessageBox.Show("Das Programm wertet noch eine vorherige Anfrage aus.")
                Return
            End If
            _Table = _Tables(lbTable.SelectedIndex)
            bgwLoad.RunWorkerAsync()
        End If
        _Connection.Close()
    End Sub

    Private Sub bgwLoad_DoWork(sender As System.Object, e As System.ComponentModel.DoWorkEventArgs) Handles bgwLoad.DoWork
        Invoke(Sub()
                   lbTable.Enabled = False
                   lbSchema.Enabled = False
                   cbSuche.Enabled = False
                   btnGo.Enabled = False
               End Sub)
        _DataTable = TryCast(dgvContent.DataSource, DataTable)
        _DataTable = New DataTable
        Using adapter = _ProviderFactory.CreateDataAdapter, command = _ProviderFactory.CreateCommand
            adapter.SelectCommand = command
            command.Connection = _Connection
            If e.Argument Is btnGo Then
                Invoke(Sub() command.CommandText = cbSuche.Text)
                Try
                    adapter.Fill(_DataTable)
                Catch ex As Exception
                    MessageBox.Show(command.CommandText & ": Fehler bei SQL-Statement" &
                                    vbNewLine &
                                    ex.Message.ToString)
                End Try
            Else
                command.CommandText = "SELECT * FROM ´" & _Table & "´"
                Try
                    adapter.Fill(_DataTable)
                Catch ex As Exception
                    command.CommandText = "SELECT * FROM [" & _Table & "]"
                    Try
                        adapter.Fill(_DataTable)
                    Catch ex2 As Exception
                        MessageBox.Show(command.CommandText & ": Fehler bei SQL-Statement" &
                                        vbNewLine &
                                        ex.Message.ToString)
                    End Try
                End Try
            End If
            Invoke(Sub()
                       cbSuche.Text = command.CommandText
                       For Each Filter As String In cbSuche.Items
                           If Filter = cbSuche.Text Then Return
                       Next
                       dgvContent.DataSource = _DataTable
                       cbSuche.Items.Add(cbSuche.Text)
                   End Sub)
        End Using
        Invoke(Sub()
                   lbTable.Enabled = True
                   lbSchema.Enabled = True
                   cbSuche.Enabled = True
                   btnGo.Enabled = True
               End Sub)
    End Sub

    Private Sub frmDataspy_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim commandLineArgs() = My.Application.CommandLineArgs.ToArray
        Dim dataPath = ""
        _DataTable = New DataTable
        If commandLineArgs.Length = 0 Then
            Dim ofd As New OpenFileDialog
            If Not ofd.ShowDialog = DialogResult.OK Then Return
            dataPath = ofd.FileName
            OpenWithFile(dataPath)
        Else
            If commandLineArgs.Length = 1 Then
                If File.Exists(commandLineArgs(0)) Then
                    dataPath = commandLineArgs(0)
                    OpenWithFile(dataPath)
                Else
                    OpenQuery(OleDbFactory.Instance, commandLineArgs(0))
                End If
            ElseIf commandLineArgs.Length = 2 Then
                Select Case commandLineArgs(0).ToLower
                    Case "mysql"
                        OpenQuery(MySqlClientFactory.Instance, commandLineArgs(1))
                    Case "sqlite"
                        OpenQuery(SQLite.SQLiteFactory.Instance, commandLineArgs(1))
                    Case "sqlserver"
                        OpenQuery(SqlCeProviderFactory.Instance, commandLineArgs(1))
                End Select
            End If
        End If
    End Sub

    Private Sub btnGo_Click(sender As Object, e As System.EventArgs) Handles btnGo.Click
        If Not cbSuche.Text.ToLower.StartsWith("select ") Then
            MessageBox.Show("Es sind nur Select-Statements erlaubt.")
            Return
        End If
        If bgwLoad.IsBusy Then
            MessageBox.Show("Das Programm wertet noch eine vorherige Anfrage aus.")
            Return
        End If
        _Filter = ""
        bgwLoad.RunWorkerAsync(btnGo)
    End Sub

    Private Sub tsmiOpen_Click(sender As System.Object, e As System.EventArgs) Handles tsmiOpen.Click
        Dim ofd As New OpenFileDialog
        Dim dataPath = ""
        If Not ofd.ShowDialog = DialogResult.OK Then Return
        dataPath = ofd.FileName
        OpenWithFile(dataPath)
    End Sub

    Private Sub tsmiReadme_Click(sender As System.Object, e As System.EventArgs) Handles tsmiReadme.Click
        MessageBox.Show(File.ReadAllText(Path.GetFullPath(".\Readme.txt")))
    End Sub

    Private Sub tsmiSchemeShowHide_Click(sender As System.Object, e As System.EventArgs) Handles tsmiSchemeShowHide.Click
        scSelect.Panel1Collapsed = Not scSelect.Panel1Collapsed
    End Sub

    Private Sub tsmiExport_Click(sender As System.Object, e As System.EventArgs) Handles tsmiExport.Click
        Try
            DGVnachExcel(DirectCast(DirectCast(DirectCast(sender, ToolStripMenuItem).GetCurrentParent, ContextMenuStrip).SourceControl, DataGridView))
        Catch ex As Exception
        End Try
    End Sub

    Private Sub dgvContent_DragDrop(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles dgvContent.DragDrop
        Dim data = DirectCast(e.Data, DataObject)
        Dim file = data.GetFileDropList.Item(0)
        OpenWithFile(file)
    End Sub

    Private Sub dgvContent_DragEnter(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles dgvContent.DragEnter
        e.Effect = DragDropEffects.All
    End Sub

    Private Sub dgvContent_SelectionChanged(sender As Object, e As System.EventArgs) Handles dgvContent.SelectionChanged
        tsmiExclude.Visible = Not dgvContent.SelectedCells.Count.Equals(0)
        tsmiSearch.Visible = Not dgvContent.SelectedCells.Count.Equals(0)
    End Sub

    Private Sub Search(sender As System.Object, e As System.EventArgs)
        For i = 0 To dgvContent.SelectedCells.Count - 1
            Dim cell = dgvContent.SelectedCells(i)
            If Not String.IsNullOrEmpty(_Filter) Then
                If sender Is tsmiSearch AndAlso _
                   i > 0 AndAlso _
                   cell.OwningColumn Is dgvContent.SelectedCells(i - 1).OwningColumn Then
                    _Filter += " OR "
                Else
                    _Filter += " AND "
                End If
            End If
            If cell.Value.ToString = "" Then
                If sender Is tsmiSearch Then
                    _Filter += "["c & cell.OwningColumn.HeaderText & "] IS NULL "
                ElseIf sender Is tsmiExclude Then
                    _Filter += "NOT [" & cell.OwningColumn.HeaderText & "] IS NULL "
                End If
            Else
                Dim vz = ""
                If sender Is tsmiExclude Then vz = "<>" Else vz = "="
                Select Case cell.OwningColumn.ValueType.ToString
                    Case "System.Text", "System.String"
                        _Filter += "["c & cell.OwningColumn.HeaderText & "] " & vz & " '"
                        _Filter += cell.Value.ToString & "'"
                    Case "System.Int16", "System.Int32", "System.Int64", "System.Double", "System.Decimal", "System.Single", "System.Boolean"
                        _Filter += "["c & cell.OwningColumn.HeaderText & "] " & vz & " "
                        _Filter += cell.Value.ToString
                    Case "System.DateTime"
                        _Filter = String.Format("CONVERT([{0}], System.String) {1} '{2}'", _
                                                cell.OwningColumn.HeaderText, _
                                                vz, _
                                                DateTime.Parse(cell.Value.ToString).ToString("MM\/dd\/yyyy HH:mm:ss"))
                End Select
            End If
        Next
        dgvContent.DataSource = Nothing
        dgvContent.DataSource = _DataTable.Select(_Filter).CopyToDataTable
    End Sub

    Private Sub OpenWithFile(ByVal dataPath As String)
        If dataPath.ToLower.EndsWith("csv") Or dataPath.ToLower.EndsWith("txt") Then
            OpenQuery(OleDbFactory.Instance, _
               "Provider=Microsoft.Jet.OLEDB.4.0; Extended Properties=""text;HDR=Yes;FMT=Delimited""; Data Source='", New FileInfo(dataPath).DirectoryName, "';")
        ElseIf dataPath.ToLower.EndsWith("mdb") Then
            OpenQuery(OleDbFactory.Instance, _
               "Provider=Microsoft.Jet.OLEDB.4.0;Persist Security Info=True; Data Source='", dataPath, "';")
        ElseIf dataPath.ToLower.EndsWith("accdb") Then
            OpenQuery(OleDbFactory.Instance, _
               "Provider=Microsoft.ACE.OLEDB.12.0;Data Source='", dataPath, "'")
        ElseIf dataPath.ToLower.EndsWith("db") Then
            OpenQuery(SQLite.SQLiteFactory.Instance, "Data Source=", dataPath)
        ElseIf dataPath.ToLower.EndsWith("sdf") Then
            OpenQuery(SqlCeProviderFactory.Instance, "Data Source='", dataPath, "';")
        ElseIf dataPath.ToLower.EndsWith("xls") Then
            OpenQuery(OleDbFactory.Instance, _
               "Provider=Microsoft.Jet.OLEDB.4.0; Extended Properties=""Excel 8.0""; Data Source='", dataPath, "';")
        ElseIf dataPath.ToLower.EndsWith("xlsx") Then
            OpenQuery(OleDbFactory.Instance, _
               "Provider=Microsoft.ACE.OLEDB.12.0;Data Source='", dataPath, "';Extended Properties=""Excel 12.0 Xml;HDR=YES"";")
        End If
    End Sub

    Public Sub OpenQuery(ByVal ProviderFactory As DbProviderFactory, ByVal ParamArray Connection() As String)
        ResetControls()
        _ProviderFactory = ProviderFactory
        _Connection = ProviderFactory.CreateConnection
        _Connection.ConnectionString = String.Concat(Connection)
        Try
            _Connection.Open()
        Catch ex As DbException
            If ex.Message.ToLower.Contains("kennwort") Then
                Dim password As String = InputBox("Bitte geben Sie das Kennwort ein.")
                _Connection.ConnectionString += "Jet OLEDB:Database Password=" & password & ";"
                _Connection.Open()
            End If
        End Try
        Dim mainSchema = _Connection.GetSchema()
        _Schemes.AddRange(From dataRow In mainSchema Select Name = dataRow(0).ToString)
        _DataTable = mainSchema
        dgvContent.DataSource = _DataTable
        Try
            Dim tableSchema = _Connection.GetSchema("Tables")
            For Each dataRow As DataRow In tableSchema.Rows
                If dataRow("TABLE_TYPE").ToString.ToLower.Equals("table") Then
                    _Tables.Add(dataRow("TABLE_NAME").ToString)
                End If
            Next
            tableSchema.Dispose()
        Catch

        End Try
        _Connection.Close()
        lbSchema.DataSource = Nothing
        lbSchema.DataSource = _Schemes
        lbTable.DataSource = Nothing
        lbTable.DataSource = _Tables
        AddHandler lbSchema.SelectedIndexChanged, AddressOf lb_SelectedIndexChanged
        AddHandler lbTable.SelectedIndexChanged, AddressOf lb_SelectedIndexChanged
        AddHandler tsmiSearch.Click, AddressOf Search
        AddHandler tsmiExclude.Click, AddressOf Search
        Me.BringToFront()
    End Sub

    Private Sub ResetControls()
        RemoveHandler lbSchema.SelectedIndexChanged, AddressOf lb_SelectedIndexChanged
        RemoveHandler lbTable.SelectedIndexChanged, AddressOf lb_SelectedIndexChanged
        RemoveHandler tsmiSearch.Click, AddressOf Search
        RemoveHandler tsmiExclude.Click, AddressOf Search
        _DataTable.Clear()
        _Schemes.Clear()
        _Tables.Clear()
        cbSuche.Text = ""
        _Filter = ""
    End Sub
    
End Class

